﻿
extraWeights = {};

function extraWeights.prerequisitesPresent(specializations)
    return true;
end;

function extraWeights:load(xmlFile)

	self.weightState = SpecializationUtil.callSpecializationsFunction("weightState");

	self.extraWeights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.extraWeights#count"), 0);
    self.weights = {};
    for i=1, self.extraWeights do
        local weightnamei = string.format("vehicle.extraWeights.weight%d", i);
        self.weights[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, weightnamei .. "#index"));
        setVisibility(self.weights[i], false);
    end;
	
	self.emptyMass = getMass(self.components[1].node);
		if self.emptyMass == 0 then
			self.emptyMass = 74;
		end;	
		
	self.currentWeight = 300;
	self.weightsActive = false;
end;

function extraWeights:update(dt)
	if self.isClient then
		if self.isEntered then
			if InputBinding.hasEvent(InputBinding.WEIGHT_ACTIVE) then
				self.weightsActive = not self.weightsActive;
				self:weightState(self.weightsActive);--MP
			end;
		end;
	end;
	if self.weightsActive then
		for i = 1, self.extraWeights do
			setVisibility(self.weights[i], true);
		end;
		setMass(self.components[1].node, (self.emptyMass + self.currentWeight));
		for k,v in pairs(self.components) do
			if v.node == self.components[1].node then
				if v.centerOfMass ~= nil then
					setCenterOfMass(v.node, v.centerOfMass[1], v.centerOfMass[2], v.centerOfMass[3], v.centerOfMass[4] );
				end;
				break;
			end;
		end;
	else
		for i = 1, self.extraWeights do
			setVisibility(self.weights[i], false);
		end;
		self.testMass = self.emptyMass + self.currentWeight
		if self.testMass > self.emptyMass then
			self.testor = self.testMass - self.currentWeight;
			setMass(self.components[1].node, self.testor);
			for k,v in pairs(self.components) do
				if v.node == self.components[1].node then
					if v.centerOfMass ~= nil then
						setCenterOfMass(v.node, v.centerOfMass[1], v.centerOfMass[2], v.centerOfMass[3], v.centerOfMass[4] );
					end;
					break;
				end;
			end;
		end;
	end;
end;

function extraWeights:weightState(weightsActive, noEventSend)
	extraWeightsEvent.sendEvent(self, weightsActive, noEventSend);
	if weightsActive then
		self.weightsActive = true;
	else
		self.weightsActive = false;
	end;
end;



function extraWeights:onLeave()
end;
function extraWeights:draw()
end;
function extraWeights:delete()
end;
function extraWeights:mouseEvent(posX, posY, isDown, isUp, button)
end;
function extraWeights:keyEvent(unicode, sym, modifier, isDown)
end;




extraWeightsEvent = {};
extraWeightsEvent_mt = Class(extraWeightsEvent, Event);

InitEventClass(extraWeightsEvent, "extraWeightsEvent");

function extraWeightsEvent:emptyNew()
    local self = Event:new(extraWeightsEvent_mt);
    self.className="extraWeightsEvent";
    return self;
end;

function extraWeightsEvent:new(vehicle, weightsActive)
    local self = extraWeightsEvent:emptyNew()
    self.vehicle = vehicle;
	self.weightsActive = weightsActive;
    return self;
end;

function extraWeightsEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.weightsActive = streamReadBool(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function extraWeightsEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.weightsActive);
end;

function extraWeightsEvent:run(connection)
	self.vehicle:weightState(self.weightsActive, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(extraWeightsEvent:new(self.vehicle, self.weightsActive), nil, connection, self.vehicle);
    end;
end;

function extraWeightsEvent.sendEvent(vehicle, weightsActive, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(extraWeightsEvent:new(vehicle, weightsActive), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(extraWeightsEvent:new(vehicle, weightsActive));
		end;
	end;
end;
